window.Gleam.initSearch([{"doc":"glitr_lustre","title":"glitr_lustre","content":"# glitr_lustre\n\nInterface for lustre to use Glitr&#39;s typed routes\n\n[![Package Version](https://img.shields.io/hexpm/v/glitr_lustre)](https://hex.pm/packages/glitr_lustre)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/glitr_lustre/)\n\n```sh\ngleam add glitr_lustre\n```\n```gleam\nimport glitr_lustre\nimport lustre\n\npub fn main() {\n  let app = lustre.application(init, update, view)\n  let assert Ok(_) = lustre.start(app, &quot;#app&quot;, Nil)\n\n  Nil\n}\n\nfn update(model: Model, msg: Msg) -&gt; #(Model, Effect(Msg)) {\n  case msg {\n    TodoAdded(title) -&gt; #(model, glitr_lustre.send_to_route(\n      todo_routes.create(),\n      Nil,\n      CreateTodo(title),\n      ServerCreatedTodo,\n    ))\n    ServerCreatedTodo(Ok(new_todo)) -&gt; #([new_todo, ..model], effect.none())\n    _ -&gt; #(model, effect.none())\n  }\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/glitr_lustre&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n","url":"index.html"},{"doc":"glitr_lustre","title":"RouteRequest","content":"pub type RouteRequest(p, q, b, c, msg) {\n  RouteRequest(\n    route: glitr.Route(p, q, b, c),\n    options: option.Option(glitr.RouteOptions(p, q, b)),\n    as_msg: fn(Result(c, lustre_http.HttpError)) -&gt; msg,\n  )\n}\n\nRouteRequest(\n  route: glitr.Route(p, q, b, c),\n  options: option.Option(glitr.RouteOptions(p, q, b)),\n  as_msg: fn(Result(c, lustre_http.HttpError)) -&gt; msg,\n)\n\n\nSynonyms:\nglitr_lustre.RouteRequest\nglitr_lustre RouteRequest","url":"glitr_lustre.html#RouteRequest"},{"doc":"glitr_lustre","title":"send","content":"pub fn send(\n  request: RouteRequest(a, b, c, d, e),\n  on_error: fn(String) -&gt; Effect(e),\n) -&gt; Effect(e)\n\nSynonyms:\nglitr_lustre.send\nglitr_lustre send","url":"glitr_lustre.html#send"},{"doc":"glitr_lustre","title":"send_to_route","content":"pub fn send_to_route(\n  route: Route(a, b, c, d),\n  path: a,\n  query: b,\n  body: c,\n  as_msg: fn(Result(d, HttpError)) -&gt; e,\n) -&gt; Effect(e)\n\nSynonyms:\nglitr_lustre.send_to_route\nglitr_lustre send_to_route","url":"glitr_lustre.html#send_to_route"},{"doc":"glitr_lustre","title":"to_route_request","content":"pub fn to_route_request(\n  route: Route(a, b, c, d),\n) -&gt; RouteRequest(a, b, c, d, Nil)\n\nSynonyms:\nglitr_lustre.to_route_request\nglitr_lustre to_route_request","url":"glitr_lustre.html#to_route_request"},{"doc":"glitr_lustre","title":"with_msg","content":"pub fn with_msg(\n  request: RouteRequest(a, b, c, d, e),\n  as_msg: fn(Result(d, HttpError)) -&gt; e,\n) -&gt; RouteRequest(a, b, c, d, e)\n\nSynonyms:\nglitr_lustre.with_msg\nglitr_lustre with_msg","url":"glitr_lustre.html#with_msg"},{"doc":"glitr_lustre","title":"with_options","content":"pub fn with_options(\n  request: RouteRequest(a, b, c, d, e),\n  options: RouteOptions(a, b, c),\n) -&gt; RouteRequest(a, b, c, d, e)\n\nSynonyms:\nglitr_lustre.with_options\nglitr_lustre with_options","url":"glitr_lustre.html#with_options"},{"doc":"glitr_lustre","title":"glitr_lustre","content":"","url":"glitr_lustre.html"}]);